/* Programming activity: Image slide show
 *
 * Finish this GUI program that displays a sequence of images 
 * given as command line arguments. The program cycles through
 * the images, displaying each for one second.
 * 
 * Part 1, add/change code in ShowImages to correctly parse the
 * command line input (marked TODO 1)
 * 
 * Part 2, add/change code in ShowImagesPanel to display to 
 * track and display the different images.
 *  
 */

import javax.imageio.ImageIO;
import javax.swing.*;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class ShowImages
{
    // The go methods takes the array of Strings passed to the program
    public void go(String [] filenames)
    {
        // Call our parent frame constructor so we can set our title
        JFrame frame = new JFrame("ShowImages");

        // Create the custom panel that draws the slideshow
        ShowImagesPanel panel = new ShowImagesPanel();

        // Add the custom panel to the frame
        frame.getContentPane().add(panel);

        int maxWidth  = 0;
        int maxHeight = 0;
        int numImages = 0;
        
        // Loop over all the image filenames
        for (String s : filenames)
        {
            // Load the image from the filename s
            BufferedImage image = null;
            try
            {
                // TODO 1: Use the ImageIO.read method to load the image with filename s
                image = null;
            }
            catch (IOException e)
            {
                // We just skip over filenames that aren't found
            }

            // Only add images that were successfully loaded
            if (image != null)
            {
                // TODO 1: Figure out the width and height of the loaded image
                int width = 0;
                int height = 0;
                
                // TODO 1: Keep track of the maximum width and height of any image
                maxWidth  = 0;
                maxHeight = 0;
                
                System.out.printf("%s [%d x %d]\n", s, width, height);
                panel.addImage(image);
                
                // Track how many total actual images we loaded
                numImages++;
            }
        }
        
        // Give up if we didn't load any images
        if (numImages == 0)
        {
            System.out.println("ERROR: no images loaded!");
            return;
        }
        System.out.printf("Loaded %d images, max width = %d, max height = %d\n", numImages, maxWidth, maxHeight);
        
        
        // This makes sure the content pane of the JFrame is big enough
        // to fit the biggest width and height of any of the images.
        frame.getContentPane().setPreferredSize(new Dimension(maxWidth, maxHeight));
        frame.pack();

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);	

        // Fire up the thread in the panel object that periodically flips
        // the picture and forces a repaint.
        panel.startShow();
    }

    public static void main(String [] args)
    {
        ShowImages gui = new ShowImages();
        gui.go(args);
    }
}
